unit Main;

interface

uses WinTypes, WinProcs, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, toolhelp, ClipBrd, utils, FEdit2,
  mtbase, about, Tabs, insp3, fedutils, typinfo,
  {bigtimer, }splash, regfake, pform, inifiles;

const
  PaletteGroupIndex=10;
  PWM_CloseEdit : word=0;
  PWM_FixDesignMode : Word=0;
  hcRuntime=20;
  hcContents=10;

type
  TRTDPMainForm_CSL = class(TForm)
    MainMenu1: TMainMenu;
    FileItem: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    SaveDialog: TSaveDialog;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    PasteButton: TSpeedButton;
    CopyButton: TSpeedButton;
    SaveButton: TSpeedButton;
    OpenBtn: TSpeedButton;
    CutButton: TSpeedButton;
    DelButton: TSpeedButton;
    DelItem: TMenuItem;
    ShowInspectorItem: TMenuItem;
    MinimizeAllItem: TMenuItem;
    ShowControlCentre1: TMenuItem;
    N3: TMenuItem;
    AlignToGridItem: TMenuItem;
    BringToFrontItem: TMenuItem;
    SendToBackItem: TMenuItem;
    Options1: TMenuItem;
    LiveDragItem: TMenuItem;
    FullIntersectItem: TMenuItem;
    DesignBar: TMenuItem;
    RunBar: TMenuItem;
    MinimizeallRuntimeItem: TMenuItem;
    TXTtoRDFItem: TMenuItem;
    RDFtoTXTItem: TMenuItem;
    N4: TMenuItem;
    SetCaptiontoFilenameItem: TMenuItem;
    N5: TMenuItem;
    HelponHelp1: TMenuItem;
    TutorButton: TSpeedButton;
    SHowHints1: TMenuItem;
    HelpButton: TSpeedButton;
    Label1: TLabel;
    EditForm: TLabel;
    ShowPalette1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FileNewItemClick(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure FileOpenItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure FileSaveItemClick(Sender: TObject);
    Function SaveForm(Form : TForm; SaveAs : Boolean) : Boolean;
    procedure FileSaveAsItemClick(Sender: TObject);
    procedure CutItemClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure PasteItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure OnComponentClick(Sender: TObject);
    procedure DelButtonClick(Sender: TObject);
    procedure FileCloseItemClick(Sender: TObject);
    procedure Run1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    Function PrepareClose(SaveOnly : Boolean) : Boolean;
    procedure ShowInspectorItemClick(Sender: TObject);
    procedure MinimizeAllItemClick(Sender: TObject);
    procedure ShowControlCentre1Click(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DelItemClick(Sender: TObject);
    procedure AlignToGridItemClick(Sender: TObject);
    procedure BringToFrontItemClick(Sender: TObject);
    procedure SendToBackItemClick(Sender: TObject);
    procedure LiveDragItemClick(Sender: TObject);
    procedure FullIntersectItemClick(Sender: TObject);
    procedure MinimizeallRuntimeItemClick(Sender: TObject);
    procedure RDFtoTXTItemClick(Sender: TObject);
    procedure TXTtoRDFItemClick(Sender: TObject);
    procedure SetCaptiontoFilenameItemClick(Sender: TObject);
    procedure HelponHelp1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure DesignCentre1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TutorButtonClick(Sender: TObject);
    procedure SHowHints1Click(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure ShowPalette1Click(Sender: TObject);
  Protected
    FMapFile : TIniFile;
    { Next two are for the example show }
    FDemoRunning : Boolean;
    FDemoList : TList;
    FDemoHandle : Integer;
    FDemoName : TFilename;
    FDemoTimer : Longint;
    FRequestStartDemo : Boolean;
    FDemoArray : PChar;

    FDoneFirstShow : Boolean;
    OldCaption : String;
    Oldfilename : TFilename;
    OldForm : TForm;
    OldDesigner : TFormEditor2;
    FInsertComponentClass : TComponentClass;
    FnameCounter : Integer;
    FDesignMode : Boolean;
    FObtainedCustom : Boolean;
    Procedure ShowForm(Form : TForm);
    Procedure PrepareSizeInfo(Form : TForm);
    Procedure FreeSizeInfo(Form : TForm);
    Function FindFormByFilename(Filename : TFilename) : TForm;
    Procedure OpenFile(Filename : TFilename);
    procedure RuntimeFormClose(Sender: TObject; var Action: TCloseAction);
    procedure RuntimeFormResize(Sender: TObject);
    Procedure WndProc(var Message: TMessage); override;
{    Function NextName : String;}
    Function GetFInserting : Boolean;
    Procedure OnIdle(Sender: TObject; var Done: Boolean);
    Procedure WMGetMinMaxInfo(var Message : TWMGETMinMaxInfo); message WM_GetMinMaxInfo;
    Function getnewName : TFilename;
    Procedure ProcessMyParams;
    Procedure ProcessParams(Params : TStringList);
    Procedure MinimizeAll(DesignMode : Boolean);
    Procedure AddWindowmenu(Form : TForm; NewCaption : String; IsDesignBar : Boolean);
    Procedure RemoveWindowMenu(Form : TForm);
    procedure RenameWindowmenu(Form : TForm; NewCaption : String);
    Procedure OnADesignWindowClick(Sender : TObject);
    Procedure SetDesignmode(Value : Boolean);
    Procedure ObtainCustom;
    Procedure FreakMenu(Form : TForm);
    procedure ShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
    procedure RunExampleItemClick(Sender: TObject); virtual; abstract;
  public
    { Public declarations }
    FMapName : TFileName;
    Procedure FixEnabled;
    Constructor Create(AComponent : TComponent); override;
    Destructor Destroy; override;
    Function CheckOverwrite(var Filename : TFilename) : boolean;
    Procedure ConvertRDFtoTXT(var RDFFilename: TFilename; TXTFilename : TFilename);
    Procedure ConvertTXTtoRDF(var TXTFilename: TFilename; RDFFilename : TFilename);
    Function GetFormCaption(Form : TForm; MaxSize : Integer) : String;
    Procedure NewFromResources(ResourceName,NewName : String);
    Procedure NotifyActiveForm(Form : TForm);
    Function TopForm(RunTimeOnly : Boolean) : TForm;
    Procedure SaveFile(Form : TForm; FileName : TFilename; Filehandle : Integer);
    Function LoadFile(FileName : TFilename; var FileHandle : Integer; Permissions : Word) : TStream;
    Procedure ToBin(IfileName, OFilename : TFileName);
    Procedure CopyComponent(ComponentClass : TComponentClass);
    Procedure EditStream(Stream : TStream; Editname : TFileName; Filehandle : Integer);
    Function RunStream(Stream : TStream) : TForm;
    Property InsertComponentClass : TComponentClass Read FInsertComponentClass Write FInsertComponentClass;
    Property Inserting : Boolean Read GetFInserting;
    Procedure GotInsert;
    Procedure RunFile(Filename : TFilename);
    Function Closeform(Form : TForm; SaveOnly : Boolean) : Boolean;
    Procedure FlipInspector;
    Property DesignMode : Boolean Read FDesignmode Write SetDesignmode;
    Property MapFile : TIniFile Read FMapFile;
  end;

  Function MakeSCNumber(I : Integer) : String;

var
  RTDPMainForm_CSL : TRTDPMainForm_CSL;

implementation

{$R *.DFM}
{$R NEW.RDF}

{Function GetParent : String;
var
  TE : TTaskEntry;
  ME : TModuleEntry;           
begin
  Result:='';
  TE.dwSize:=SizeOf(TE);
  if not TaskFindHandle(@TE,GetCurrentTask) then exit;
  if not TaskFindHandle(@TE,TE.hTaskParent) then exit;
  ME.dwSize:=SizeOf(ME);
  If ModuleFindHandle(@ME,TE.hModule)=0 then exit;
  Result:=StrPas(ME.szExePath);
end;
}
procedure TRTDPMainForm_CSL.FormCreate(Sender: TObject);
begin
  FMapName:=ExtractFilePath(Application.Exename)+'Property.map';
  FMapFile:=TIniFile.Create(FMapName);
  Application.OnIdle:=OnIdle;
  LiveDragItem.Checked:=Fedit2.LiveDrag;
  FullIntersectItem.Checked:=Fedit2.FullIntersect;
  ShowHints1.Checked:=Application.Showhint;
  FNameCounter:=1;
  ParentShowHint:=True;
  { Set our "Current Item" indicators to blank }
  NotifyActiveForm(nil);
end;

{ Stuff's params into a StringList and then processes them }
{ That way when we receive a message from another instance with its params }
{ (and we HAVE to make a copy quickly), we can also stuff them into a string list }
{ and use the same processing routine }
Procedure TRTDPMainForm_CSL.ProcessMyParams;
var
  Params : TStringList;
  C : Integer;
begin
  FDesignMode:=true;
  Params:=TStringList.Create;
  try
    C:=1; while c<=ParamCount do begin
      Params.Add(ParamStr(c));
      inc(c);
    end;
    ProcessParams(Params);
  finally
    Params.free;
  end;
end;

{ Here we could be in an OnShow or not, who can tell.... }
Procedure TRTDPMainForm_CSL.ProcessParams;
var
  c : integer;
  Des : Boolean;
  TPath : TFilename;
begin
  If Params.Count>0 then begin
    { scan params }
    { if a /d is shown then show designer }
    TPath:='';
    c:=0; while c<Params.Count do begin
      try
        If CompareText(Params[c],'/d')=0 then
          DesignMode:=True
        else If CompareText(Params[c],'/rd')=0 then
          RunExampleItemClick(nil)
        else if Comparetext(Params[c],'/p')=0 then begin
          inc(c);
          If C<Params.Count then begin
            TPath:=params[c];
            TPath:=MakePath(TPath);
          end;
        end else begin
          { add TPath if there is no path }
          If ExtractFilePath(Params[c])='' then
            RunFile(TPath+Params[c])
          else
            RunFile(Params[c]);
          Self.SendToBack;
        end;
      except
        On E: Exception do
          Application.ShowException(E);
      end;
      inc(c);
    end;
  end;
end;

procedure TRTDPMainForm_CSL.FileNewItemClick(Sender: TObject);
begin
  NewFromResources('NEW.RDF',GetNewName);
end;

procedure TRTDPMainForm_CSL.FileOpenItemClick(Sender: TObject);
var
  S : String;
begin
  { is it wise to do this blindly - yes, a dialog.filename always has a path }
  S:=ExtractFilePath(OpenDialog.filename);
  OpenDialog.InitialDir:=S;
  S:=ExtractFilename(OpenDialog.filename);
  OpenDialog.Filename:=S;
  OpenDialog.FilterIndex:=1;
  if OpenDialog.Execute then begin
    OpenFile(OpenDialog.Filename);
  end;
end;

procedure TRTDPMainForm_CSL.OpenFile;
var
  Stream : TStream;
  FileHandle : Integer;
  Form : TForm;
begin
  { first check if that file is open, and if so warn them, and bring to front instead }
  Form:=FindFormByFileName(FileName);
  If Form<>nil then begin
    MessageDlg('File '+Filename+' is already being edited',mtInformation,[mbOK],0);
    Form.BringToFront;
  end else begin
    { The editor will close the file when done }
    { Editstream will close it if there was an exception }
    { SAMFIX do we want to keep the file open?  This can cause data loss if windows crashes... }
    { perhaps we should close it and when we re-open test to see if the file was modified and warn then... }
    Stream:=LoadFile(OpenDialog.Filename,FileHandle,fmOpenReadWrite or fmShareDenyWrite);
    try
      EditStream(Stream,OpenDialog.Filename,FileHandle);
    finally
      Stream.Free;
    end;
  end;
end;

{ Return a stream for the file, also return a valid file handle - }
{ we are using windows file locking to stop others writing to the file }
Function TRTDPMainForm_CSL.LoadFile;
var
  Stream, MStream : TStream;
  Temphandle : Integer;
begin
  Temphandle:=FileOpen(Filename,Permissions);
  { Return the file handle if they wanted it }
  If @FileHandle<>nil then FileHandle:=Temphandle;
  { we are bound to raise an exception if we cnnot open stream }
  If TempHandle<0 then
    Raise Exception.Create('Cannot open file '+Filename);
  { Decide how to construct the stream }
  { SAMFIX there should be some better method, other than file extension }
  If UpperCase(ExtractfileExt(Filename))='.TXT' then begin
    Stream:=THandleStream.Create(TempHandle);
    try
      { Do a quick ObjectTextToResource to get a binary version }
      MStream:=TMemoryStream.Create;
      ObjectTextToResource(Stream,MStream);
      MStream.Seek(0,0);
      Result:=MStream;
    finally
      Stream.Free;
    end;
  end else begin { otherwise hand over stream itself }
    Stream:=THandleStream.Create(TempHandle);
    Result:=Stream;
  end;
end;

{ Return the top level form which must either be a runtime form or an editform }
{ SAMFIX Currently these are TFORM only, we should change this to allow a special form }
{ which would save a lot of trouble, but cause a pain changing it }
Function TRTDPMainForm_CSL.TopForm;
var
  c : Integer;
  Form : TForm;
  Editing : Boolean;
begin
  Result:=nil;
  c:=0;
  While c<Screen.FormCount do begin
    Form:=Screen.Forms[c];
    If (Form.ClassType=TForm) and ((Form.Designer=nil) or (not RunTimeOnly)) then begin
      { If its a TFORM exactly, then it must be us, everything else is some descedant }
      result:=Form as TForm;
      break;
    end;
    inc(c);
  end;
end;

{ Check if there is a form DESIGNING whose associated filename is the given filename }
{ We don't do any checking to see if a file could be accessed by 2 names }
{ which might technically be possible with a convoluted network setup }
Function TRTDPMainForm_CSL.FindFormByFilename;
var
  c : Integer;
  Form : TForm;
  Editing : Boolean;
begin
  Result:=nil;
  c:=0;
  While c<Screen.FormCount do begin
    Form:=Screen.Forms[c];
    { Again, check for exact TFORM class } { and some kind of designer }
    If (Form.ClassType=TForm) and (Form.Designer<>nil) then
      If (Form.Designer as TFormEditor2).Filename=Filename then begin
        result:=Form as TForm;
        break;
      end;
    inc(c);
  end;
end;

procedure TRTDPMainForm_CSL.FileSaveItemClick(Sender: TObject);
var
  Form : TForm;
begin
  { Inspector.Active form is always the toplevel form }
  { Don't call this until the inspector is created }
  Form:=Inspector.ActiveForm;
  If Form<>nil then
    SaveForm(Form,false);
  FixEnabled;
end;

{ Only designed to save forms with an editor - which contains the filename }
{ and file handle and other such stuff }
Function TRTDPMainForm_CSL.SaveForm;
var
  MStream, Stream : TStream;
  Editor : TFormEditor2;
  Filename : TFilename;
  Ready, DoSave, Confirm : Boolean;
  NewHandle : Integer;
begin
  Result:=False;
  { bring to front to emphasize which form they are operating on }
  Form.BringtoFront;
  If Form.Designer=nil then
    Raise Exception.Create('Can only save editing forms.  This Error Shouldn''t happen!')
  else begin
    { SAMFIX we keep doing all this AS stuff }
    Editor:=(Form.Designer as TFormEditor2);
    FileName:=Editor.Filename;
    { If it doesn't have an open handle, it can't have been saved, so get confirmation }
    { SAMFIX if we ditch the open handle concept we need some other indication of this }
    Confirm:=Editor.FileHandle<0;
    { Decide we WILL save until the user cancels it }
    DoSave:=True;
    Ready:=not(Confirm or SaveAs);
    while not Ready do begin{ repeat until we have a valid name and handle }
      { keep doing this, else dialog gets path in name section }
      SaveDialog.FileName:=ExtractFileName(Filename);
      SaveDialog.InitialDir:=ExtractFilePath(Filename);

      { keep calling savedialog until success or until they cancel }
      if SaveDialog.Execute then begin
        { if new name, then close old handle and get a new one }
        try
          if Editor.Filename<>SaveDialog.FileName then begin
            { only close if we CAN get a new one, so try and open the new one first }
            newhandle:=FileCreateShare(SaveDialog.Filename, fmOpenReadWrite or fmShareDenyWrite);
            If NewHandle<0 then { failed } {SAMFIX should explain why }
              Raise Exception.Create('Cannot create file '+SaveDialog.Filename);
            { well... may as well close the old handle now }
            If Editor.FileHandle>=0 then
              FileClose(Editor.Filehandle);
            Editor.Filehandle:=Newhandle;
            Editor.Filename:=SaveDialog.FileName;
          end;
          Ready:=True;
        except { if error, show it, and go round again }
          On E: Exception do
            Application.ShowException(E);
        end;
      end else begin { cancelled dialog }
        DoSave:=False;
        Ready:=true;
      end;
    end;
    { now we now we have a valid name and handle }
    If DoSave then begin
      SaveFile(Form,Editor.Filename,Editor.Filehandle);
      Result:=true;
    end;
  end;
end;

Procedure TRTDPMainForm_CSL.Savefile;
var
  Stream, MStream : TStream;
  ResName : String;
begin
  { better truncate the file handle to 0 }
  FileSeek(FileHandle,0,0);
  FileWrite(FileHandle,pointer(nil)^,0);

  Stream:=THandleStream.Create(Filehandle);
  try
    Resname:=Form.Classname;
    { Use filename instead, that makes it easy to link them back into Delphi source by name }
    ResName:=UpperCase(ExtractFilename(filename));
    If UpperCase(ExtractfileExt(Filename))<>'.TXT' then begin
      Stream.WriteComponentRes(Resname,Form);
    end else begin
      MStream:=TMemoryStream.Create;
      MStream.WriteComponent(Form);
      MStream.Seek(0,0);
      ObjectBinaryToText(MStream,Stream);
      MStream.Free;
    end;
  finally
    Stream.Free;
  end;
  { SAMFIX should flush file here.... }
  { After a successful save, the form on file must be up to date, so.... }
  (Form.Designer as TFormEditor2).FormModified:=False;
end;

procedure TRTDPMainForm_CSL.FileSaveAsItemClick(Sender: TObject);
var
  Editor : TFormEditor2;
  Form : TForm;
begin
  { save current file under new name }
  Form:=Inspector.ActiveForm;
  If Form<>nil then
    SaveForm(Form,true);
end;

procedure TRTDPMainForm_CSL.FileExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TRTDPMainForm_CSL.CutItemClick(Sender: TObject);
var
  Form : TForm;
begin
  {cut selection to clipboard}
  Form:=Inspector.ActiveForm;
  If Form<>nil then begin
    Form.BringtoFront;
    ((Form.Designer) as TFormEditor2).Cut;
  end;
end;

{XXXX}

procedure TRTDPMainForm_CSL.CopyItemClick(Sender: TObject);
var
  Form : TForm;
begin
  {copy selection to clipboard}
  Form:=Inspector.ActiveForm;
  If Form<>nil then begin
    Form.BringtoFront;
    ((Form.Designer) as TFormEditor2).Copy;
  end;
end;

procedure TRTDPMainForm_CSL.PasteItemClick(Sender: TObject);
var
  Form : TForm;
begin
  {paste from clipboard}
  Form:=Inspector.ActiveForm;
  If Form<>nil then begin
    Form.BringtoFront;
    ((Form.Designer) as TFormEditor2).Paste;
  end;
end;

procedure TRTDPMainForm_CSL.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TRTDPMainForm_CSL.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TRTDPMainForm_CSL.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TRTDPMainForm_CSL.FormDestroy(Sender: TObject);
begin
  Screen.OnActiveFormChange:=nil;
  FEdit2.KillDesigners;
end;

Procedure TRTDPMainForm_CSL.ToBin;
var
  IStream, OStream : TStream;
begin
  IStream:=TFileStream.Create(Ifilename,fmOpenRead);
  OStream:=TFileStream.Create(Ofilename,fmCreate);
  try
    ObjectTextToBinary(IStream,OStream);
  finally
    OStream.Free;
    IStream.Free;
  end;
end;

Procedure TRTDPMainForm_CSL.CopyComponent;
begin
  InsertComponentClass:=ComponentClass;
end;

procedure TRTDPMainForm_CSL.CheckBox1Click(Sender: TObject);
begin
  FEdit2.LiveDrag:=(Sender as TSpeedButton).Down;
end;

procedure TRTDPMainForm_CSL.OnComponentClick(Sender: TObject);
var
  SpeedButton : TSpeedButton;
begin
  try
    SpeedButton:=Sender as TSpeedButton;
    CopyComponent(TComponentClass(SpeedButton.Tag));
    Palette.ActiveSpeedButton:=SpeedButton;
  except
    SpeedButton.Down:=False;
    Raise;
  end;
end;

{ all opens come through this point }
procedure TRTDPMainForm_CSL.EditStream;
var
  Editor : TFormEditor2;
begin
  try
    Visible:=True;
    Editor:=TFormEditor2.Create;
    { We don't need to do AddWindowMenu, we will be added when Object inspector tries to rename us }
    Editor.StartEdit(Stream,Editname,FileHandle);
  except
    If not FileHandle<0
      then FileClose(FileHandle);
    Editor.Free;
    Raise;
  end;
  FixEnabled;
end;

{Function TRTDPMainForm_CSL.NextName;
const
  NameCount : Integer=0;
begin
  Inc(NameCount);
  Result:='Form_'+IntToStr(NameCount);
end;}

Function TRTDPMainForm_CSL.GetFInserting;
begin
  Result:=FInsertComponentClass<>nil;
end;

Procedure TRTDPMainForm_CSL.GotInsert;
begin
  { Pop up the button! }
  FInsertComponentClass:=nil;
  Palette.ReleaseAllButtons;
end;

Procedure TRTDPMainForm_CSL.OnIdle;
begin
  SwitchThreadNow;
  Done:=ThreadCount=1;
end;

procedure TRTDPMainForm_CSL.DelButtonClick(Sender: TObject);
var
  Form : TForm;
begin
  {cut selection to clipboard}
  Form:=Inspector.ActiveForm;
  If Form<>nil then begin
    Form.BringtoFront;
    ((Form.Designer) as TFormEditor2).Delete;
  end;
end;

procedure TRTDPMainForm_CSL.FileCloseItemClick(Sender: TObject);
var
  Form : TForm;
begin
  Form:=TopForm(false);
  If Form<>nil then begin
    CloseForm(Form,false);
  end;
end;

Function TRTDPMainForm_CSL.CloseForm;
var
  Editor : TFormEditor2;
  R : Word;

  Procedure CloseEditing;
  begin
    If not SaveOnly then begin
      RemoveWindowMenu(Form);
      FileClose(Editor.FileHandle);
      Editor.StopEdit;
      Editor.Free;
    end;
    Result:=true;
  end;

begin
  Result:=false;
  Editor:=(Form.Designer as TFormEditor2);
  If Editor<>nil then begin
    try
      Editor.CommitChanges;
    except
      On E: Exception do begin
        Editor.FormModified:=true; { fake a change, cos they may need to redspond to this }
        Application.ShowException(E);
      end;
    end;
    If Editor.FormModified then begin
      { Prompt save changes }
      while true do begin
        Form.BringToFront;
        R:=MessageDlg('Save changes to form '''+Editor.Filename+''' before close?',mtConfirmation,mbyesNoCancel,0);
        Case R of
          mrYes: begin
            If SaveForm(Form,false) then begin
              CloseEditing;
              break;
            end else
              Continue; { They can't bomb out by cancelling the save dialog }
                        { they must say CANCEL to the save question, or NO to }
                        { just not save this form }
          end;
          mrNo: begin
            CloseEditing;
            break;
          end;
          mrCancel: break;
        end;
      end;
    end else
      CloseEditing;
  end else begin
    if not SaveOnly then begin
      Form.Close; {samfix this is the closing of a runtime form }
                  { remove window menu will happen in onclose }
    end;
    Result:=true;
  end;
  FixEnabled;
end;

procedure TRTDPMainForm_CSL.Run1Click(Sender: TObject);
var
  LoadForm : TForm;
  Stream : TStream;
  S : String;
begin
  { is it wise to do this blindly - yes, a dialog.filename always has a path }
  S:=ExtractFilePath(OpenDialog.filename);
  OpenDialog.InitialDir:=S;
  S:=ExtractFilename(OpenDialog.filename);
  OpenDialog.Filename:=S;
  OpenDialog.Filterindex:=1;
  if OpenDialog.Execute then begin
    RunFile(OpenDialog.Filename);
  end;
end;

procedure TRTDPMainForm_CSL.RunFile;
var
  LoadForm : TForm;
  Stream : TStream;
  Filehandle : Integer;
begin
  Stream:=LoadFile(Filename,Integer(nil^),fmOpenRead or fmShareDenyNone);
  try
    RunStream(Stream);
  finally
    FileClose(FileHandle);
    Stream.Free;
  end;
  FixEnabled;
end;

Function TRTDPMainForm_CSL.RunStream;
var
  Form : TForm;
  P : longint;
begin
  Result:=nil;
  form:=nil;
  Form:=TForm.Create(Application);
  Form.Icon.Handle:=LoadIcon(hInstance,'RUNTIMEICON');
  try
    try
      P:=Stream.Position;
      Stream.ReadResHeader;
    except
      Stream.Position:=P;
    end;
    Stream.ReadComponent(Form);
    Form.OnClose:=RuntimeFormClose;
    Form.OnResize:=RuntimeFormReSize;
    Form.Visible:=True;
    Form.HelpContext:=hcRunTime;
    PrepareSizeInfo(Form);
    AddWindowMenu(Form,Form.Caption,false);
    FreakMenu(Form);
    FObtainedCustom:=True;
  except
    Form.Free;
    Raise;
  end;
  Result:=Form;
end;

Procedure TRTDPMainForm_CSL.WMGetMinMaxInfo;
begin
  Inherited;
  If not (csLoading in ComponentState) then begin
    Message.Result:=0;
    With Message.MinMaxInfo^ do begin
      ptMaxSize.Y:=Height;
      ptMaxTrackSize:=ptMaxSize;
      ptMinTrackSize.Y:=height;
      ptMinTrackSize.X:=200;
    end;
  end;
end;

Procedure TRTDPMainForm_CSL.WndProc;
begin
  If Message.msg=WM_QueryEndSession then begin
    Message.Result:=longint(PrepareClose(true));
  end else if Message.MSG=PWM_FixDesignMode then begin
    If Message.LParam<>0 then
      PostMessage(Handle,Message.MSG,Message.WParam,Message.LParam-1)
    else begin
      Visible:=FDesignMode;
      If FDesignMode then SplashForm.Free; { probably already free }
                                           { its on hide sets itelf to nil }
      If Message.wparam<>0 then LockWindowUpdate(0);
      If not FDesignMode and (TopForm(false)=nil) then begin
        If not FObtainedCustom then
          ObtainCustom
        else
          Close;
      end else SplashForm.Free; { obtained custom from command line }
    end;
  end else If Message.MSG=PWM_CloseEdit then begin
      Message.Result:=0;
      CloseForm(TForm(Message.LParam),false);
  end else
    Inherited WndProc(Message);
end;

procedure TRTDPMainForm_CSL.FlipInspector;
var
  XForm : TForm;
  Form : TForm;
  C : Integer;
begin
  { check for F11 }
  If Inspector.Visible then begin
    If Inspector.WindowState=wsMinimized then
      Inspector.WindowState:=wsNormal
    else begin
      Form:=Inspector.ActiveForm;
      If Form<>nil then
        c:=0; while C<screen.formcount do begin
          XForm:=Screen.Forms[c];
          If XForm=Inspector then begin
            Form.BringToFront;
            Break;
          end else if XForm=Form then begin
            inspector.BringToFront;
            Break;
          end;
          inc(c);
        end;
      end;
  end;
end;

{ disable buttons and menu items if no form is being edited }
Procedure TRTDPMainForm_CSL.FixEnabled;
var
  Enable : Boolean;
  C : Integer;
  Component : TComponent;
  SpeedButton : TSpeedButton;
begin
  Enable:=Inspector.ActiveForm<>nil;
  { all speed buttons which have PaletteGroupIndex }
  C:=0; while C<ComponentCount do begin
    Component:=Components[c];
    If Components[c] is TSpeedButton then with
      (Components[c] as TSpeedButton) do begin
        If GroupIndex=paletteGroupIndex then
          Enabled:=Enable;
      end;
    inc(c);
  end;
  { Now for buttons }
  DelButton.Enabled:=Enable;
  CutButton.Enabled:=Enable;
  CopyButton.Enabled:=Enable;
  PasteButton.Enabled:=Enable;
  If OldDesigner<>nil then
    SaveButton.Enabled:=Enable and OldDesigner.FormModified
  else
    SaveButton.Enabled:=Enable;

  { Now for menu items }
  With MainMenu1 do begin
    FileSaveItem.Enabled:=Enable;
    FileSaveAsItem.Enabled:=Enable;
    FileCloseItem.Enabled:=(TopForm(false)<>nil);
    MinimizeallRuntimeItem.Enabled:=(TopForm(true)<>nil);
    CutItem.Enabled:=Enable;
    CopyItem.Enabled:=Enable;
    PasteItem.Enabled:=Enable;
    DelItem.Enabled:=Enable;
    ShowInspectorItem.Enabled:=Enable;
    MinimizeAllItem.Enabled:=Enable;
    AlignToGridItem.Enabled:=Enable;
    BringToFrontItem.Enabled:=Enable;
    SendToBackItem.Enabled:=Enable;
    SetCaptiontoFilenameItem.Enabled:=Enable;
  end;
end;

Function TRTDPMainForm_CSL.GetNewname;
begin
  Result:='NoName'+IntToStr(FNameCOunter);
  inc(FNameCounter);
  If FNameCounter>99 then FNameCounter:=1;
end;

procedure TRTDPMainForm_CSL.SpeedButton3Click(Sender: TObject);
begin
  FixEnabled;
end;

procedure TRTDPMainForm_CSL.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  If PrepareClose(false) then Action:=caFree
  else Action:=caNone;
end;

Function TRTDPMainForm_CSL.PrepareClose;
var
  Form : TForm;
  Forms : TList;
  C : Integer;
begin
  Result:=True;
  { Here we need to close everything else and save it }
  { first make a list of forms }
  try
    Forms:=TList.Create;
    try
      c:=0; while c<Screen.FormCount do begin
        Form:=Screen.Forms[c];
        If Form.Designer<>nil then
          forms.Add(Form);
        inc(c);
      end;
      c:=0;
      while c<Forms.Count do begin
        Form:=Forms[c];
        try
          If not CloseForm(Form as TForm,SaveOnly) then begin
            Result:=False;
            break;
          end;
        except
          On E: Exception do
            Application.ShowException(E)
        end;
        inc(c);
      end;
    finally
      Forms.Free;
    end;
  except
    on E: Exception do begin
      Application.ShowException(E);
      result:=false;
    end;
  end;
end;

procedure TRTDPMainForm_CSL.ShowInspectorItemClick(Sender: TObject);
begin
  FlipInspector;
end;

Function TRTDPMainForm_CSL.GetFormCaption;

  Function TruncFilename(Filename : TFilename; MaxSize : Integer) : TFilename;
  var
    name, path : TFilename;
  const
    filler='...';
  begin
    If length(filename)>MaxSize then begin
      { the last part of the name is most important }
      Name:=ExtractFilename(Filename);
      if length(name)<maxsize then begin
        { The next most is the drive }
        if length(name)+length(filler)>=maxsize then
          result:=copy(filler,1,maxsize-length(name))+name
        else begin
          path:=extractfilepath(filename);
          Result:=copy(path,1,MaxSize-length(name)-length(filler))+filler+name;
        end;
      end else
        Result:=filler+copy(name,1,MaxSize);
    end else
      Result:=Filename;
  end;

  Function TruncCaption(Caption : String; MaxSize : Integer) : String;
  var
    Miss : integer;
  const
    filler='...';
  begin
    If MaxSize<=length(filler) then begin
      Result:=copy(filler,1,maxsize)
    end else if MaxSize<length(caption) then begin
      Miss:=length(caption)+length(filler)-MaxSize;
      Result:=copy(Caption,1,(length(caption)-miss+1) div 2)+filler+copy(caption,(length(caption)+miss) div 2,255);
    end else
      Result:=caption;
  end;

var
  FormCaption, Filename : String;
  Editor : TFormEditor2;
begin
  If Form<>nil then begin
    FormCaption:=Form.Caption;
    Editor:=TFormEditor2(Form.Designer);
    If Editor<>nil then
      Filename:=Editor.Filename
    else
      Filename:='';
    If (FormCaption<>Filename) and (filename<>'') then begin
      Filename:='('+TruncFilename(Filename,MaxSize-2)+')';
      formCaption:=TruncCaption(Formcaption+' ',MaxSize-length(filename));
      FormCaption:=FormCaption+Filename;
    end else begin { caption is filename but take filename, as it truncs better }
      FormCaption:=TruncFilename(Filename,MaxSize);
    end;
  end else
    FormCaption:='';
  Result:=FormCaption;
end;

procedure TRTDPMainForm_CSL.NotifyActiveForm;
var
  Editor : TFormEditor2;
  Filename : TFilename;
begin
  If Form=nil then begin
    OldCaption:='';
    OldFilename:='';
    OldForm:=nil;
    OldDesigner:=nil;
    EditForm.Caption:='No active form';
  end else begin
    Editor:=TFormEditor2(Form.Designer);
    If Editor<>nil then
      Filename:=Editor.filename
    else
      Filename:='';                                    { if new form may be new edit needs inserting }
    If (OldCaption<>Form.Caption) or (Filename<>OldFilename) or (Form<>OldForm) then begin
      OldCaption:=Form.Caption;
      OldFilename:=Filename;
      OldForm:=Form;
      OldDesigner:=Editor;

      EditForm.Caption:=GetFormCaption(Form,70);
      If Editor<>nil then
        RenameWindowmenu(Form,GetFormCaption(Form,255));
    end;
  end;
  { adjust the filesave button }
  { If it was nil it would already ave been called }
  If OldDesigner<>nil then FixEnabled;
end;

Procedure TRTDPMainForm_CSL.MinimizeAll;
var
  c : Integer;
  Form : TForm;
  Forms : TList;
begin
  { Look for the first form in Screen.Forms that is one of us! }
  { as changing minimized affects z order we must make a copy first }
  Forms:=TList.Create;
  try
    c:=0;
    While c<Screen.FormCount do begin
      Form:=Screen.Forms[c];
      If (DesignMode=(Form.designer<>nil)) and (Form.ClassType=TForm) then
        Forms.Add(Form);
      inc(c);
    end;
    c:=0; while c<Forms.Count do begin
      SendMessage(TForm(Forms[c]).Handle,WM_SYSCOMMAND,SC_Minimize,0);
      inc(c);
    end;
    If Inspector.Visible then Inspector.WindowState:=wsMinimized;
  finally
    Forms.Free;
  end;
end;

procedure TRTDPMainForm_CSL.MinimizeAllItemClick(Sender: TObject);
begin
  { minimize all designer windows }
  MinimizeAll(True);
end;

procedure TRTDPMainForm_CSL.AddWindowMenu;
var
  CurrentItem : TMenuItem;
  C : Integer;
  I : Integer;
  Bar : Integer;
begin
  CurrentItem:=TMenuItem.Create(Self);
  CurrentItem.OnClick:=OnADesignWindowClick;
  CurrentItem.Tag:=longint(Form);
  { Make bar visible }
  If IsDesignBar then begin
    I:=Window1.IndexOf(RunBar)-Window1.IndexOf(DesignBar);
    CurrentItem.Caption:=MakeSCNumber(I)+' '+NewCaption;
    DesignBar.Visible:=True;
    Window1.Insert(Window1.IndexOf(Runbar),CurrentItem);
  end else begin
    CurrentItem.Caption:=NewCaption;
    RunBar.Visible:=True;
    Window1.Insert(Window1.Count,CurrentItem);
  end;
(*
  Window1.Insert(C,CurrentItem);


  { Parse the window menu, look for the first bar, or the end }
  I:=0;
  Bar:=-1;
  C:=0; while c<Window1.Count do begin
    CurrentItem:=Window1.Items[c];
    inc(i);
    If CurrentItem.Caption='-' then begin
      If Bar<>-1 then break; { we want to be after first bar }
      i:=0; { start counting again }
      Bar:=c;
    end;
    inc(c);
  end;
  If Bar=-1 then begin
    CurrentItem:=TMenuItem.Create(Self);
    CurrentItem.Caption:='-';;
    Window1.Insert(C,CurrentItem);
    i:=0;
    Bar:=c;
    inc(c);
  end;
  { Insert the window here }
  inc(i);
  CurrentItem:=TMenuItem.Create(Self);
  CurrentItem.Caption:=MakeSCNumber(I)+' '+NewCaption;
  CurrentItem.OnClick:=OnADesignWindowClick;
  CurrentItem.Tag:=longint(Editor);
  Window1.Insert(C,CurrentItem);*)
end;

procedure TRTDPMainForm_CSL.RenameWindowMenu;
var
  CurrentItem : TMenuItem;
  C : Integer;
  I : Integer;
  Done : Boolean;

begin
  { Parse the window menu, look for the first bar, or the end }
  I:=0;
  Done:=False;
  C:=Window1.Indexof(Designbar); while c<Window1.Count do begin
    CurrentItem:=Window1.Items[c];
    If CurrentItem.Tag=longint(Form) then begin
      CurrentItem.Caption:=MakeSCNumber(I)+' '+NewCaption;
      done:=true;
      break;
    end;
    inc(i);
    inc(c);
  end;
  If not Done then { add one }
    AddWindowMenu(Form,NewCaption,true);
end;

procedure TRTDPMainForm_CSL.RemoveWindowMenu;
var
  CurrentItem : TMenuItem;
  C : Integer;
  DesignIndex, RunIndex : Integer;

  Function Rename(Caption : String; I : Integer) : String;
  var
    P : Integer;
  begin
    P:=pos(' ',Caption);
    Result:=MakeSCNumber(I)+' '+Copy(Caption,p+1,255);
  end;

  Procedure RenameFromBar;
  var
    i : Integer;
  begin
    i:=1;
    c:=Designindex+1; while c<RunIndex do begin
      CurrentItem:=Window1.Items[c];
      CurrentItem.Caption:=Rename(CurrentItem.Caption,i);
      inc(i);
      inc(c);
    end;
  end;

begin
  { We may have to invisible the preceding bar if there are no other children }
  C:=Window1.IndexOf(DesignBar); while c<Window1.Count do begin
    CurrentItem:=Window1.Items[c];
    If CurrentItem.Tag=longint(Form) then begin
      Window1.Delete(c);
      RunIndex:=Window1.IndexOf(RunBar);
      Designindex:=Window1.IndexOf(DesignBar);
      If c<=RunIndex then begin { is design form } { do <= not < as we have deleted it now and maybe moved runindex... }
        RenameFromBar;
        If (RunIndex=DesignIndex+1) then DesignBar.Visible:=False;
      end else begin
        If RunIndex=Window1.Count-1 then RunBar.Visible:=False;
      end;
      break;
    end;
    inc(c);
  end;
end;

procedure TRTDPMainForm_CSL.OnADesignWindowClick;
var
  Form : TForm;
begin
  If Sender is TMenuItem then begin
    Form:=TForm((Sender as TMenuItem).Tag);
    If Sysminimized(form) then
      SendMessage(Form.Handle,WM_SYSCOMMAND,SC_Restore,0);
    Form.BringToFront;
  end;
end;

Function MakeSCNumber(I : Integer) : String;
begin
  If (i<10) and (i>=0) then
    Result:='&'+IntToStr(I)
  else
    result:=IntToStr(I);
end;

procedure TRTDPMainForm_CSL.ShowControlCentre1Click(Sender: TObject);
begin
  BringToFront;
end;

procedure TRTDPMainForm_CSL.HelpAboutItemClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TRTDPMainForm_CSL.FormShow(Sender: TObject);
begin
  {$IFDEF DEBUG}
  Debugform.Visible:=True;
  {$ENDIF}

  if not FDoneFirstShow then begin
    FDoneFirstShow:=True;
    FixEnabled;
    ProcessMyParams;
    If not FDesignMode then begin
      LockWindowUpdate(Handle);
      PostMessage(Handle,PWM_FixDesignMode,$FFFF,0); {-1 to tell it to unlock window update }
    end else
      SplashForm.Free;
  end;
end;

procedure TRTDPMainForm_CSL.DelItemClick(Sender: TObject);
var
  Form : TForm;
begin
  {cut selection to clipboard}
  Form:=Inspector.ActiveForm;
  If Form<>nil then begin
    Form.BringtoFront;
    ((Form.Designer) as TFormEditor2).Delete;
  end;
end;

procedure TRTDPMainForm_CSL.RuntimeFormClose(Sender: TObject;
  var Action: TCloseAction);
var
  Form : TForm;
begin
  Form:=(Sender as TForm);
  FreeSizeInfo(Form);
  Action:=caFree;
  RemoveWindowmenu(Form);
  { samfix this is BAAADDDDD but how else can we tell when form is GONE? }
  PostMessage(Handle,PWM_FixDesignMode,0,2);
end;

procedure TRTDPMainForm_CSL.AlignToGridItemClick(Sender: TObject);
var
  Designer : TFormEditor2;
begin
  {copy selection to clipboard}
  Designer:=(Inspector.ActiveEditor as TFormEditor2);
  If Designer<>nil then begin
    Designer.Form.BringtoFront;
    Designer.MenuAlign(Sender);
  end;
end;

procedure TRTDPMainForm_CSL.BringToFrontItemClick(Sender: TObject);
var
  Designer : TFormEditor2;
begin
  {copy selection to clipboard}
  Designer:=(Inspector.ActiveEditor as TFormEditor2);
  If Designer<>nil then begin
    Designer.Form.BringtoFront;
    Designer.MenuBringToFront(Sender);
  end;
end;

procedure TRTDPMainForm_CSL.SendToBackItemClick(Sender: TObject);
var
  Designer : TFormEditor2;
begin
  {copy selection to clipboard}
  Designer:=(Inspector.ActiveEditor as TFormEditor2);
  If Designer<>nil then begin
    Designer.Form.BringtoFront;
    Designer.MenuSendToBack(Sender);
  end;
end;

procedure TRTDPMainForm_CSL.NewFromResources;
var
  Handle: Integer;
  Stream: TStream;
begin
  Handle := OpenResource(ResourceName,longint(nil^));
  try
    Stream := THandleStream.Create(Handle);
    try
      EditStream(Stream,newname,-1);
    finally
      Stream.Free;
    end;
  finally
    FileClose(Handle);
  end;
end;

procedure TRTDPMainForm_CSL.LiveDragItemClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked:=not (Sender as TMenuItem).Checked;
  FEdit2.LiveDrag:=(Sender as TMenuItem).Checked;
end;

procedure TRTDPMainForm_CSL.FullIntersectItemClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked:=not (Sender as TMenuItem).Checked;
  Fedit2.FullIntersect:=(Sender as TMenuItem).Checked;
end;

procedure TRTDPMainForm_CSL.SetDesignmode;
begin
  FDesignMode:=Value;
  If FDoneFirstShow then begin
    PostMessage(Handle,PWM_FixDesignmode,0,0);
  end;
end;

procedure TRTDPMainForm_CSL.ObtainCustom;
begin
  while true do
    If OpenDialog.Execute then
      try
        SplashForm.Free;
        RunFile(OpenDialog.Filename);
        break;
      except
        On E: Exception do
          Application.ShowException(E);
      end
    else begin
      { we may be designing by now }
      If not FDesignmode then
        close;
      break;
    end;
end;

procedure TRTDPMainForm_CSL.MinimizeallRuntimeItemClick(Sender: TObject);
begin
  MinimizeAll(false);
end;

procedure TRTDPMainForm_CSL.FreakMenu;
var
  FormMenu : HMenu;
begin
{  FormMenu:=GetSystemMenu(Form.Handle,False);
  InsertMenu(FormMenu,0,mf_separator or mf_byposition,0,nil);
  InsertMenu(FormMenu,0,mf_enabled or mf_byposition,100,'&Run new form');}
end;

procedure TRTDPMainForm_CSL.RuntimeFormResize;
var
  OriginalWidth, Originalheight : Integer;
  PreviousWidth, PreviousHeight : Integer;
  Form : TForm;
  AutoScrolling : Boolean;
  NewWidth, Newheight : Integer;
const
  lock : boolean=false;
begin
  if lock then exit;
  lock:=true;
  try
    Form:=Sender as TForm;
    { if already scaled then undo scale }
    PreviousWidth:=HiWord(Form.tag);
    PreviousHeight:=LoWord(Form.tag);
    OriginalWidth:=HiWord(Form.DesignInfo);
    OriginalHeight:=LoWord(Form.DesignInfo);
    NewWidth:=form.Width;
    Newheight:=Form.height;
    { form already has new proportion as a result of user sizing }
    { Undo this and allow forms dimensions to be reached with scaling based on the sized size }
    Form.Width:=PreviousWidth;
    Form.Height:=PreviousHeight;

    If Form.Tag<>Form.DesignInfo then begin
      { designInfo is original scale }
      Form.Scaleby(OriginalWidth,PreviousWidth);
    end;
    Form.ScaleBy(NewWidth,OriginalWidth);
    Form.Tag:=makeLong(Form.Height,Form.Width);
    Form.update;
  finally
    lock:=false;
  end;
end;

procedure TRTDPMainForm_CSL.PrepareSizeInfo;
begin
  { original size }
  Form.DesignInfo:=makeLong(form.Height,form.Width);
  { scale size }
  Form.Tag:=Form.DesignInfo;
end;

procedure TRTDPMainForm_CSL.FreeSizeInfo;
begin
end;

procedure TRTDPMainForm_CSL.RDFtoTXTItemClick(Sender: TObject);
var
  TXTFilename : TFilename;
  RDFFilename : TFilename;
begin
  OpenDialog.InitialDir:=ExtractFilePath(OpenDialog.filename);
  OpenDialog.Filename:=ExtractFilename(OpenDialog.filename);
  OpenDialog.Filterindex:=1;
  If OpenDialog.Execute then begin
    RDFFilename:=Opendialog.filename;
    TXTFileName:=ChangeFileExt(RDFFilename,'.TXT');
    SaveDialog.InitialDir:=ExtractFilePath(TXTFilename);
    SaveDialog.Filename:=ExtractFilename(TXTFilename);
    SaveDialog.Filterindex:=2;
    If SaveDialog.Execute then try
      SaveDialog.Filterindex:=1;
      TXTFilename:=Savedialog.filename;
      ConvertRDFtoTXT(RDFFilename,TXTFilename);
      ShowMessage(RDFFilename+' converted to '+TXTFilename+' as text OK');
    except
      On E: Exception do
        Application.ShowException(E);
    end;
  end;
end;

procedure TRTDPMainForm_CSL.ConvertRDFtoTXT;
var
  RDFHandle, TXTHandle : Integer;
  RDFStream : THandleStream;
  TXTStream : THandleStream;
begin
  RDFHandle:=FileOpen(RDFFilename,fmOpenRead or fmShareDenyNone);
  If RDFHandle<0 then
    Raise Exception.Create('Cannot open file '+RDFfilename);
  try
    TXTHandle:=FileCreateShare(TXTFilename,fmOpenReadWrite or fmShareExclusive);
    If TXTHandle<0 then
      Raise Exception.Create('Could not create file '+TXTfilename);
    { now create two streams and go! }
    try
      try
        RDFStream:=THandleStream.Create(RDFHandle);
        TXTStream:=THandleStream.Create(TXTHandle);
        try
          ObjectResourceToText(RDFStream,TXTStream);
        finally
          RDFStream.Free;
          TXTStream.Free;
        end;
      finally
        FileClose(TXTHandle);
      end;
    except
      { delete the TXTHandle }
      { SAMFIX maybe not if its the best they've got.... }
      DeleteFile(TXTFileName);
      Application.ShowException(Exception(ExceptObject));
    end;
  finally
    FileClose(RDFHandle);
  end;
end;

procedure TRTDPMainForm_CSL.TXTtoRDFItemClick(Sender: TObject);
var
  TXTFilename : TFilename;
  RDFFilename : TFilename;
begin
  OpenDialog.InitialDir:=ExtractFilePath(OpenDialog.filename);
  OpenDialog.Filename:=ExtractFilename(OpenDialog.filename);
  OpenDialog.FilterIndex:=2;
  If OpenDialog.Execute then begin
    OpenDialog.FilterIndex:=1;
    TXTFilename:=Opendialog.filename;
    RDFFileName:=ChangeFileExt(TXTFilename,'.RDF');
    SaveDialog.InitialDir:=ExtractFilePath(RDFFilename);
    SaveDialog.Filename:=ExtractFilename(RDFFilename);
    SaveDialog.FilterIndex:=1;
    If SaveDialog.Execute then try
      RDFFilename:=Savedialog.filename;
      ConvertTXTtoRDF(TXTFilename,RDFFilename);
      ShowMessage(TXTFilename+' converted to '+RDFFilename+' as RDF format OK');
    except
      On E: Exception do
        Application.ShowException(E);
    end;
  end;
end;

procedure TRTDPMainForm_CSL.ConvertTXTtoRDF;
var
  RDFHandle, TXTHandle : Integer;
  RDFStream : THandleStream;
  TXTStream : THandleStream;
begin
  TXTHandle:=FileOpen(TXTFilename,fmOpenRead or fmShareDenyNone);
  If TXTHandle<0 then
    Raise Exception.Create('Cannot open file '+TXTfilename);
  try
    RDFHandle:=FileCreateShare(RDFFilename,fmOpenReadWrite or fmShareExclusive);
    If RDFHandle<0 then
      Raise Exception.Create('Could not create file '+rdffilename);
    { now create two streams and go! }
    try
      try
        TXTStream:=THandleStream.Create(TXTHandle);
        RDFStream:=THandleStream.Create(RDFHandle);
        try
          ObjectTextToResource(TXTStream,RDFStream);
        finally
          TXTStream.Free;
          RDFStream.Free;
        end;
      finally
        FileClose(RDFHandle);
      end;
    except
      { delete the RDFHandle }
      { SAMFIX maybe not if its the best they've got.... }
      DeleteFile(RDFFileName);
      Application.ShowException(Exception(ExceptObject));
    end;
  finally
    FileClose(TXTHandle);
  end;
end;

Function TRTDPMainForm_CSL.CheckOverwrite;
begin
  if FileExists(Filename) then begin
    Case messagedlg(Filename+' already exists.  Do you want to overwrite?',
        mtWarning,mbYesNoCancel,0) of
      mrNo: begin
        OpenDialog.InitialDir:=ExtractFilePath(Filename);
        OpenDialog.Filename:=ExtractFilename(Filename);
        Result:=OpenDialog.Execute;
      end;
      mrYes: Result:=true;
      mrCancel: Result:=false;
    else
      Result:=False;
    end;
  end else
    Result:=true;
end;

procedure TRTDPMainForm_CSL.SetCaptiontoFilenameItemClick(Sender: TObject);
var
  Form : TForm;
  Editor : TFormEditor2;
begin
  { Inspector.Active form is always the toplevel form }
  { Don't call this until the inspector is created }
  Form:=Inspector.ActiveForm;
  If Form<>nil then begin
    Form.BringToFront;
    Editor:=(Form.Designer as TFormEditor2);
    If Editor<>nil then begin
      Form.Caption:=Editor.Filename;
      Editor.Modified;
    end;
  end;
end;

Procedure TRTDPMainForm_CSL.ShowForm;
begin
  If Sysminimized(form) then
    SendMessage(Form.Handle,WM_SYSCOMMAND,SC_Restore,0);
  Form.BringToFront;
end;

Constructor TRTDPMainForm_CSL.Create;
begin
  Inherited Create(AComponent);
  FDemoList:=TList.Create;
  Application.OnShowHint:=ShowHint;
end;

Destructor TRTDPMainForm_CSL.Destroy;
begin
  FMapFile.Free;
  Inherited Destroy;
end;

procedure TRTDPMainForm_CSL.HelponHelp1Click(Sender: TObject);
begin
  winhelp(Application.Handle,nil,help_helponhelp,0);
end;

procedure TRTDPMainForm_CSL.Contents1Click(Sender: TObject);
begin
  Application.HelpContext(10);
end;

procedure TRTDPMainForm_CSL.DesignCentre1Click(Sender: TObject);
begin
  Application.HelpContext(30);
end;

procedure TRTDPMainForm_CSL.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Form : TForm;
begin
  If Key=vk_F1 then begin
    Form:=Screen.Forms[0];
    If (Form<>nil) and (Form.HelpContext<>0) then
      Application.HelpContext(Form.HelpContext);
  end;
end;

procedure TRTDPMainForm_CSL.TutorButtonClick(Sender: TObject);
begin
  Application.HelpContext(140);
end;

procedure TRTDPMainForm_CSL.SHowHints1Click(Sender: TObject);
begin
  ShowHints1.Checked:=not ShowHints1.Checked;
  Application.ShowHint:=ShowHints1.Checked;
end;

procedure TRTDPMainForm_CSL.HelpButtonClick(Sender: TObject);
begin
  Application.HelpContext(10);
end;

procedure TRTDPMainForm_CSL.ShowPalette1Click(Sender: TObject);
begin
  If Palette.Windowstate=wsMinimized then
    Palette.WindowState:=wsNormal
  else
    Palette.BringToFront;
end;

procedure TRTDPMainForm_CSL.ShowHint;
begin
  HintInfo.HintMaxWidth:=Screen.Width div 4;
end;

initialization
  PWM_CloseEdit:=RegisterWindowMessage('WM_CLOSE_EDIT');
  PWM_FixDesignMode:=RegisterWindowMessage('PWM_FIXDESIGNMODE');
end.


